// **********************************************************************
//
// Copyright (c) 2003-2015 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.0
//
// <auto-generated>
//
// Generated from file `PermissionsVerifier.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef GLACIER2_API_EXPORTS
#   define GLACIER2_API_EXPORTS
#endif
#include <Glacier2/PermissionsVerifier.h>
#include <IceUtil/PushDisableWarnings.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/BasicStream.h>
#include <Ice/SlicedData.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/PopDisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 306
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace
{

const ::std::string __Glacier2__PermissionsVerifier__checkPermissions_name = "checkPermissions";

const ::std::string __Glacier2__SSLPermissionsVerifier__authorize_name = "authorize";

}

namespace
{

const ::IceInternal::DefaultUserExceptionFactoryInit< ::Glacier2::PermissionDeniedException> __Glacier2__PermissionDeniedException_init("::Glacier2::PermissionDeniedException");

}

Glacier2::PermissionDeniedException::PermissionDeniedException(const ::std::string& __ice_reason) :
    ::Ice::UserException(),
    reason(__ice_reason)
{
}

Glacier2::PermissionDeniedException::~PermissionDeniedException() throw()
{
}

::std::string
Glacier2::PermissionDeniedException::ice_name() const
{
    return "Glacier2::PermissionDeniedException";
}

Glacier2::PermissionDeniedException*
Glacier2::PermissionDeniedException::ice_clone() const
{
    return new PermissionDeniedException(*this);
}

void
Glacier2::PermissionDeniedException::ice_throw() const
{
    throw *this;
}

void
Glacier2::PermissionDeniedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->startWriteException(__slicedData);
    __writeImpl(__os);
    __os->endWriteException();
}

void
Glacier2::PermissionDeniedException::__read(::IceInternal::BasicStream* __is)
{
    __is->startReadException();
    __readImpl(__is);
    __slicedData = __is->endReadException(true);
}

void
Glacier2::PermissionDeniedException::__writeImpl(::IceInternal::BasicStream* __os) const
{
    __os->startWriteSlice("::Glacier2::PermissionDeniedException", -1, true);
    __os->write(reason);
    __os->endWriteSlice();
}

void
Glacier2::PermissionDeniedException::__readImpl(::IceInternal::BasicStream* __is)
{
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

namespace Ice
{
}
#ifdef __SUNPRO_CC
class GLACIER2_API IceProxy::Glacier2::PermissionsVerifier;
#endif
GLACIER2_API ::IceProxy::Ice::Object* ::IceProxy::Glacier2::upCast(::IceProxy::Glacier2::PermissionsVerifier* p) { return p; }

void
::IceProxy::Glacier2::__read(::IceInternal::BasicStream* __is, ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::PermissionsVerifier>& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::PermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

bool
IceProxy::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& __p_userId, const ::std::string& __p_password, ::std::string& __p_reason, const ::Ice::Context* __ctx)
{
    __checkTwowayOnly(__Glacier2__PermissionsVerifier__checkPermissions_name);
    ::IceInternal::Outgoing __og(this, __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __ctx);
    try
    {
        ::IceInternal::BasicStream* __os = __og.startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_userId);
        __os->write(__p_password);
        __og.endWriteParams();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    if(!__og.invoke())
    {
        try
        {
            __og.throwUserException();
        }
        catch(const ::Glacier2::PermissionDeniedException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
            throw __uue;
        }
    }
    bool __ret;
    ::IceInternal::BasicStream* __is = __og.startReadParams();
    __is->read(__p_reason);
    __is->read(__ret);
    __og.endReadParams();
    return __ret;
}

::Ice::AsyncResultPtr
IceProxy::Glacier2::PermissionsVerifier::begin_checkPermissions(const ::std::string& __p_userId, const ::std::string& __p_password, const ::Ice::Context* __ctx, const ::IceInternal::CallbackBasePtr& __del, const ::Ice::LocalObjectPtr& __cookie)
{
    __checkAsyncTwowayOnly(__Glacier2__PermissionsVerifier__checkPermissions_name);
    ::IceInternal::OutgoingAsyncPtr __result = new ::IceInternal::OutgoingAsync(this, __Glacier2__PermissionsVerifier__checkPermissions_name, __del, __cookie);
    try
    {
        __result->prepare(__Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __ctx);
        ::IceInternal::BasicStream* __os = __result->startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_userId);
        __os->write(__p_password);
        __result->endWriteParams();
        __result->invoke();
    }
    catch(const ::Ice::Exception& __ex)
    {
        __result->abort(__ex);
    }
    return __result;
}

#ifdef ICE_CPP11

::Ice::AsyncResultPtr
IceProxy::Glacier2::PermissionsVerifier::__begin_checkPermissions(const ::std::string& __p_userId, const ::std::string& __p_password, const ::Ice::Context* __ctx, const ::IceInternal::Function<void (bool, const ::std::string&)>& __response, const ::IceInternal::Function<void (const ::Ice::Exception&)>& __exception, const ::IceInternal::Function<void (bool)>& __sent)
{
    class Cpp11CB : public ::IceInternal::Cpp11FnCallbackNC
    {
    public:

        Cpp11CB(const ::std::function<void (bool, const ::std::string&)>& responseFunc, const ::std::function<void (const ::Ice::Exception&)>& exceptionFunc, const ::std::function<void (bool)>& sentFunc) :
            ::IceInternal::Cpp11FnCallbackNC(exceptionFunc, sentFunc),
            _response(responseFunc)
        {
            CallbackBase::checkCallback(true, responseFunc || exceptionFunc != nullptr);
        }

        virtual void completed(const ::Ice::AsyncResultPtr& __result) const
        {
            ::Glacier2::PermissionsVerifierPrx __proxy = ::Glacier2::PermissionsVerifierPrx::uncheckedCast(__result->getProxy());
            ::std::string __p_reason;
            bool __ret;
            try
            {
                __ret = __proxy->end_checkPermissions(__p_reason, __result);
            }
            catch(const ::Ice::Exception& ex)
            {
                Cpp11FnCallbackNC::exception(__result, ex);
                return;
            }
            if(_response != nullptr)
            {
                _response(__ret, __p_reason);
            }
        }
    
    private:
        
        ::std::function<void (bool, const ::std::string&)> _response;
    };
    return begin_checkPermissions(__p_userId, __p_password, __ctx, new Cpp11CB(__response, __exception, __sent));
}
#endif

bool
IceProxy::Glacier2::PermissionsVerifier::end_checkPermissions(::std::string& __p_reason, const ::Ice::AsyncResultPtr& __result)
{
    ::Ice::AsyncResult::__check(__result, this, __Glacier2__PermissionsVerifier__checkPermissions_name);
    bool __ret;
    if(!__result->__wait())
    {
        try
        {
            __result->__throwUserException();
        }
        catch(const ::Glacier2::PermissionDeniedException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
        }
    }
    ::IceInternal::BasicStream* __is = __result->__startReadParams();
    __is->read(__p_reason);
    __is->read(__ret);
    __result->__endReadParams();
    return __ret;
}

const ::std::string&
IceProxy::Glacier2::PermissionsVerifier::ice_staticId()
{
    return ::Glacier2::PermissionsVerifier::ice_staticId();
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::PermissionsVerifier::__newInstance() const
{
    return new PermissionsVerifier;
}
#ifdef __SUNPRO_CC
class GLACIER2_API IceProxy::Glacier2::SSLPermissionsVerifier;
#endif
GLACIER2_API ::IceProxy::Ice::Object* ::IceProxy::Glacier2::upCast(::IceProxy::Glacier2::SSLPermissionsVerifier* p) { return p; }

void
::IceProxy::Glacier2::__read(::IceInternal::BasicStream* __is, ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::SSLPermissionsVerifier>& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SSLPermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

bool
IceProxy::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& __p_info, ::std::string& __p_reason, const ::Ice::Context* __ctx)
{
    __checkTwowayOnly(__Glacier2__SSLPermissionsVerifier__authorize_name);
    ::IceInternal::Outgoing __og(this, __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __ctx);
    try
    {
        ::IceInternal::BasicStream* __os = __og.startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_info);
        __og.endWriteParams();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    if(!__og.invoke())
    {
        try
        {
            __og.throwUserException();
        }
        catch(const ::Glacier2::PermissionDeniedException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
            throw __uue;
        }
    }
    bool __ret;
    ::IceInternal::BasicStream* __is = __og.startReadParams();
    __is->read(__p_reason);
    __is->read(__ret);
    __og.endReadParams();
    return __ret;
}

::Ice::AsyncResultPtr
IceProxy::Glacier2::SSLPermissionsVerifier::begin_authorize(const ::Glacier2::SSLInfo& __p_info, const ::Ice::Context* __ctx, const ::IceInternal::CallbackBasePtr& __del, const ::Ice::LocalObjectPtr& __cookie)
{
    __checkAsyncTwowayOnly(__Glacier2__SSLPermissionsVerifier__authorize_name);
    ::IceInternal::OutgoingAsyncPtr __result = new ::IceInternal::OutgoingAsync(this, __Glacier2__SSLPermissionsVerifier__authorize_name, __del, __cookie);
    try
    {
        __result->prepare(__Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __ctx);
        ::IceInternal::BasicStream* __os = __result->startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_info);
        __result->endWriteParams();
        __result->invoke();
    }
    catch(const ::Ice::Exception& __ex)
    {
        __result->abort(__ex);
    }
    return __result;
}

#ifdef ICE_CPP11

::Ice::AsyncResultPtr
IceProxy::Glacier2::SSLPermissionsVerifier::__begin_authorize(const ::Glacier2::SSLInfo& __p_info, const ::Ice::Context* __ctx, const ::IceInternal::Function<void (bool, const ::std::string&)>& __response, const ::IceInternal::Function<void (const ::Ice::Exception&)>& __exception, const ::IceInternal::Function<void (bool)>& __sent)
{
    class Cpp11CB : public ::IceInternal::Cpp11FnCallbackNC
    {
    public:

        Cpp11CB(const ::std::function<void (bool, const ::std::string&)>& responseFunc, const ::std::function<void (const ::Ice::Exception&)>& exceptionFunc, const ::std::function<void (bool)>& sentFunc) :
            ::IceInternal::Cpp11FnCallbackNC(exceptionFunc, sentFunc),
            _response(responseFunc)
        {
            CallbackBase::checkCallback(true, responseFunc || exceptionFunc != nullptr);
        }

        virtual void completed(const ::Ice::AsyncResultPtr& __result) const
        {
            ::Glacier2::SSLPermissionsVerifierPrx __proxy = ::Glacier2::SSLPermissionsVerifierPrx::uncheckedCast(__result->getProxy());
            ::std::string __p_reason;
            bool __ret;
            try
            {
                __ret = __proxy->end_authorize(__p_reason, __result);
            }
            catch(const ::Ice::Exception& ex)
            {
                Cpp11FnCallbackNC::exception(__result, ex);
                return;
            }
            if(_response != nullptr)
            {
                _response(__ret, __p_reason);
            }
        }
    
    private:
        
        ::std::function<void (bool, const ::std::string&)> _response;
    };
    return begin_authorize(__p_info, __ctx, new Cpp11CB(__response, __exception, __sent));
}
#endif

bool
IceProxy::Glacier2::SSLPermissionsVerifier::end_authorize(::std::string& __p_reason, const ::Ice::AsyncResultPtr& __result)
{
    ::Ice::AsyncResult::__check(__result, this, __Glacier2__SSLPermissionsVerifier__authorize_name);
    bool __ret;
    if(!__result->__wait())
    {
        try
        {
            __result->__throwUserException();
        }
        catch(const ::Glacier2::PermissionDeniedException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
        }
    }
    ::IceInternal::BasicStream* __is = __result->__startReadParams();
    __is->read(__p_reason);
    __is->read(__ret);
    __result->__endReadParams();
    return __ret;
}

const ::std::string&
IceProxy::Glacier2::SSLPermissionsVerifier::ice_staticId()
{
    return ::Glacier2::SSLPermissionsVerifier::ice_staticId();
}

::IceProxy::Ice::Object*
IceProxy::Glacier2::SSLPermissionsVerifier::__newInstance() const
{
    return new SSLPermissionsVerifier;
}

GLACIER2_API ::Ice::Object* Glacier2::upCast(::Glacier2::PermissionsVerifier* p) { return p; }

namespace
{
const ::std::string __Glacier2__PermissionsVerifier_ids[2] =
{
    "::Glacier2::PermissionsVerifier",
    "::Ice::Object"
};

}

bool
Glacier2::PermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__PermissionsVerifier_ids, __Glacier2__PermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::PermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__PermissionsVerifier_ids[0], &__Glacier2__PermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__PermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_staticId()
{
#ifdef ICE_HAS_THREAD_SAFE_LOCAL_STATIC
    static const ::std::string typeId = "::Glacier2::PermissionsVerifier";
    return typeId;
#else
    return __Glacier2__PermissionsVerifier_ids[0];
#endif
}

::Ice::DispatchStatus
Glacier2::PermissionsVerifier::___checkPermissions(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.startReadParams();
    ::std::string __p_userId;
    ::std::string __p_password;
    __is->read(__p_userId);
    __is->read(__p_password);
    __inS.endReadParams();
    ::std::string __p_reason;
    try
    {
        bool __ret = checkPermissions(__p_userId, __p_password, __p_reason, __current);
        ::IceInternal::BasicStream* __os = __inS.__startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_reason);
        __os->write(__ret);
        __inS.__endWriteParams(true);
        return ::Ice::DispatchOK;
    }
    catch(const ::Glacier2::PermissionDeniedException& __ex)
    {
        __inS.__writeUserException(__ex, ::Ice::SlicedFormat);
    }
    return ::Ice::DispatchUserException;
}

namespace
{
const ::std::string __Glacier2__PermissionsVerifier_all[] =
{
    "checkPermissions",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

}

::Ice::DispatchStatus
Glacier2::PermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< const ::std::string*, const ::std::string*> r = ::std::equal_range(__Glacier2__PermissionsVerifier_all, __Glacier2__PermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__PermissionsVerifier_all)
    {
        case 0:
        {
            return ___checkPermissions(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::PermissionsVerifier::__writeImpl(::IceInternal::BasicStream* __os) const
{
    __os->startWriteSlice(ice_staticId(), -1, true);
    __os->endWriteSlice();
}

void
Glacier2::PermissionsVerifier::__readImpl(::IceInternal::BasicStream* __is)
{
    __is->startReadSlice();
    __is->endReadSlice();
}

void GLACIER2_API 
Glacier2::__patch(PermissionsVerifierPtr& handle, const ::Ice::ObjectPtr& v)
{
    handle = ::Glacier2::PermissionsVerifierPtr::dynamicCast(v);
    if(v && !handle)
    {
        IceInternal::Ex::throwUOE(::Glacier2::PermissionsVerifier::ice_staticId(), v);
    }
}

GLACIER2_API ::Ice::Object* Glacier2::upCast(::Glacier2::SSLPermissionsVerifier* p) { return p; }

namespace
{
const ::std::string __Glacier2__SSLPermissionsVerifier_ids[2] =
{
    "::Glacier2::SSLPermissionsVerifier",
    "::Ice::Object"
};

}

bool
Glacier2::SSLPermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SSLPermissionsVerifier_ids, __Glacier2__SSLPermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SSLPermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SSLPermissionsVerifier_ids[0], &__Glacier2__SSLPermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SSLPermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_staticId()
{
#ifdef ICE_HAS_THREAD_SAFE_LOCAL_STATIC
    static const ::std::string typeId = "::Glacier2::SSLPermissionsVerifier";
    return typeId;
#else
    return __Glacier2__SSLPermissionsVerifier_ids[0];
#endif
}

::Ice::DispatchStatus
Glacier2::SSLPermissionsVerifier::___authorize(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.startReadParams();
    ::Glacier2::SSLInfo __p_info;
    __is->read(__p_info);
    __inS.endReadParams();
    ::std::string __p_reason;
    try
    {
        bool __ret = authorize(__p_info, __p_reason, __current);
        ::IceInternal::BasicStream* __os = __inS.__startWriteParams(::Ice::SlicedFormat);
        __os->write(__p_reason);
        __os->write(__ret);
        __inS.__endWriteParams(true);
        return ::Ice::DispatchOK;
    }
    catch(const ::Glacier2::PermissionDeniedException& __ex)
    {
        __inS.__writeUserException(__ex, ::Ice::SlicedFormat);
    }
    return ::Ice::DispatchUserException;
}

namespace
{
const ::std::string __Glacier2__SSLPermissionsVerifier_all[] =
{
    "authorize",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

}

::Ice::DispatchStatus
Glacier2::SSLPermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< const ::std::string*, const ::std::string*> r = ::std::equal_range(__Glacier2__SSLPermissionsVerifier_all, __Glacier2__SSLPermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Glacier2__SSLPermissionsVerifier_all)
    {
        case 0:
        {
            return ___authorize(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Glacier2::SSLPermissionsVerifier::__writeImpl(::IceInternal::BasicStream* __os) const
{
    __os->startWriteSlice(ice_staticId(), -1, true);
    __os->endWriteSlice();
}

void
Glacier2::SSLPermissionsVerifier::__readImpl(::IceInternal::BasicStream* __is)
{
    __is->startReadSlice();
    __is->endReadSlice();
}

void GLACIER2_API 
Glacier2::__patch(SSLPermissionsVerifierPtr& handle, const ::Ice::ObjectPtr& v)
{
    handle = ::Glacier2::SSLPermissionsVerifierPtr::dynamicCast(v);
    if(v && !handle)
    {
        IceInternal::Ex::throwUOE(::Glacier2::SSLPermissionsVerifier::ice_staticId(), v);
    }
}
